/*
 *
 *     This file is part of the Squashtest platform.
 *     Copyright (C) 2017 Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.plugin.rest.validators;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;
import org.squashtest.tm.domain.users.Party;
import org.squashtest.tm.plugin.rest.jackson.model.PartyDto;
import org.squashtest.tm.plugin.rest.jackson.model.PartyDtoVisitor;
import org.squashtest.tm.plugin.rest.jackson.model.TeamDto;
import org.squashtest.tm.plugin.rest.jackson.model.UserDto;
import org.squashtest.tm.plugin.rest.validators.helper.PartyValidationHelper;

import javax.inject.Inject;

@Component
public class PartyPostValidator implements Validator {

    @Inject
    private PartyValidationHelper partyValidationHelper;

    @Override
    public boolean supports(Class<?> clazz) {
        return Party.class.isAssignableFrom(clazz);
    }

    @Override
    public void validate(Object target, final Errors errors) {

        PartyDto partyDto = (PartyDto) target;

        if (partyDto.getId() != null) {
            errors.rejectValue("id", "generated value", "This attribute is generated by database and should not be provided. ");
        }

        PartyDtoVisitor visitor = new PartyDtoVisitor() {
            @Override
            public void visit(UserDto userDto) {
                ValidationUtils.rejectIfEmptyOrWhitespace(errors, "login", "required", "This attribute can't be empty");
                ValidationUtils.rejectIfEmptyOrWhitespace(errors, "lastName", "required", "This attribute can't be empty");
                ValidationUtils.rejectIfEmptyOrWhitespace(errors, "group", "required", "This attribute can't be empty");
                ValidationUtils.rejectIfEmptyOrWhitespace(errors, "password", "required", "This attribute can't be empty");
                partyValidationHelper.checkAndAssignValues(errors, userDto);
            }

            @Override
            public void visit(TeamDto teamDto) {
                ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "required", "This attribute can't be empty");
            }
        };

        partyDto.accept(visitor);
    }


}
